<?php
/*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2014 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class csv_pro_export extends csv_pro_api {

	function run_export($data) {

		if (isset($data['limit_lower'])) {
			$this->limit_lower = (int)$data['limit_lower'];
		}

		if (isset($data['limit_upper'])) {
			$this->limit_upper = (int)$data['limit_upper'];
		}

		if (isset($data['primary'])) $this->primary = $data['primary'];
		if (isset($data['secondary'])) $this->secondary = $data['secondary'];

		$id = $_GET['id'];
		if (!$this->getDetails($id)) die ('- id not found -');

		//$this->_checkCredentials($data);

		if (!isset($data['limit_lower'])) {
			$this->_startExport($id);
		}

		$this->password = $data['password'];
		$this->user = $data['user'];
		$delimiter = $this->_recordData['ei_delimiter'];
		// Workaround for delimiter like \t\t where it will be passed as single quoted string and will not be evaluated
		eval("\$delimiter = \"$delimiter\";");
		$this->delimiter = $delimiter;
		$this->enclosure = $this->_recordData['ei_enclosure'];
		$this->cat_tree_delimiter = $this->_recordData['ei_cat_tree_delimiter'];
		$this->id=$id;
		$this->ei_id = $this->_recordData['ei_id'];

		$data['type']=$this->_recordData['ei_type_spec'];
		$this->limit=$this->_recordData['ei_limit'];
		$this->type=$data['type'];

		switch ($this->type) {
			case 'products':
				$this->_export_products();
				break;
			case 'price_groups':
				$this->export_price_groups();
				break;

		}

	}

	/**
	 * Exports price groups to csv
	 */
	public function export_price_groups() {
		global $db,$customers_status,$language,$price;

		if ($this->limit_upper==0) $this->limit_upper = $this->limit;

		$exported_groups = $this->getExportPriceGroups();

		$exportedFields = $this->getExportedFields();
		if (empty($exportedFields)) {
			$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
			die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
		}

		if (!empty($exported_groups)) {
			$fp = $this->_openFile();
			$header_added = false;
			foreach ($exported_groups as $records) {

				if (!$header_added) {
					$this->_writeHeader($exportedFields,$fp,$this->codecs[$this->type]);
					$header_added = true;
				}

				// Get only values we care of
				$values = array();
				foreach ($exportedFields as $fieldObj) {
					// Not mapped?
					if (($fieldObj->getCsvField() == '') || (substr($fieldObj->getCsvField(), 0, strlen("No selection")) == 'No selection'))
						continue;
					if (!array_key_exists($fieldObj->getStoreField(), $records)) {
						// Constant
						$values[] = $fieldObj->getStoreField();
					} else {
						$values[] = $fieldObj->getValueForExport($records[$fieldObj->getStoreField()], $records);
					}
				}
				if (empty($values)) {
					$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
					die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
				}
				// Write to file
				fputcsv ($fp, $values, $this->delimiter, $this->enclosure);
			}
			fclose($fp);
		}

		$this->_redirecting(array("group" => $this->current_price_group));
	}

	protected function getExportPriceGroups()
	{
		global $db,$customers_status,$language,$price;
		$customer_status_list = $customers_status->_getStatusList('admin', 'true');

		if (!isset($_GET["group"])) {
			$first_status = reset($customer_status_list);
			$this->current_price_group = $first_status["id"];

			if ($this->limit_lower==0) {
				$this->force_delete = true;
			}
		} else {
			$this->current_price_group = $_GET["group"];
		}

		$total_found = 0;
		$has_next = true;
		$results = array();
		do {
			$query = "SELECT *, '{$this->current_price_group}' as group_id FROM `" . TABLE_PRODUCTS_PRICE_GROUP . $this->current_price_group . "` LIMIT " . $this->limit_lower . "," . $this->limit;

			$this->limit_lower += $this->limit;
			$rs = $db->Execute($query);
			$currentIndex = false;

			$total_found += $rs->RecordCount();

			if ($rs->RecordCount() == 0) {
				$copy = $this->current_price_group;
				reset($customer_status_list);
				foreach ($customer_status_list as $key => $value) {
					if ($currentIndex === false) {
						if ($value["id"] == $this->current_price_group) {
							$currentIndex = $key;
						}
					} else {
						$this->current_price_group = $value["id"];
						$this->limit_lower = 0;
						break;
					}
				}

				if ($copy == $this->current_price_group) {
					$has_next = false;
				}
			} else {
				while (!$rs->EOF) {
					$results[] = $rs->fields;

					$rs->MoveNext();
				}
				$rs->Close();
			}
		} while ($has_next && $total_found < $this->limit);

		$this->count = 0;

		foreach ($customers_status->_getStatusList('admin', 'true') as $key => $val) {
			$count = $db->Execute("SELECT COUNT(*) as count FROM ".TABLE_PRODUCTS_PRICE_GROUP.$val['id']);
			$this->count += $count->fields['count'];
		}

		return $results;
	}

	/**
	 * exportfunction for products + products_description + seo
	 *
	 */
	public function _export_products() {
		global $db,$customers_status,$language,$price;

		if ($this->limit_upper==0) $this->limit_upper = $this->limit;

		$query = "SELECT * FROM ".TABLE_PRODUCTS." LIMIT ".$this->limit_lower.",".$this->limit;

		$count = $db->Execute("SELECT COUNT(*) as count FROM ".TABLE_PRODUCTS);

		$this->count = $count->fields['count'];

		$_customers_status = $customers_status->_getStatusList('admin');
		$_language_list = $language->_getLanguageList();

		$rs = $db->Execute($query);

		$exportedFields = $this->getExportedFields();
		if (empty($exportedFields)) {
			$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
			die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
		}

		if ($rs->RecordCount()>0) {
			// delete if limit = 0
			$fp = $this->_openFile();
			$header_added = false;
			while (!$rs->EOF) {
				unset($rs->fields['price_flag_graduated_all']);
				unset($rs->fields['price_flag_special_all']);
				unset($rs->fields['flag_has_specials']);
				foreach ($_customers_status as $key => $val) {
					unset($rs->fields['price_flag_graduated_'.$val['id']]);
					unset($rs->fields['price_flag_special_'.$val['id']]);
				}
				$records = $rs->fields;

				// add categories info
				$cs = $db->Execute("SELECT * FROM ".TABLE_PRODUCTS_TO_CATEGORIES." WHERE products_id='".$rs->fields['products_id']."' order by master_link DESC");

				if ($cs->RecordCount()>1) {
					$cats = array();
					while (!$cs->EOF) {
						$cats[]=$cs->fields['categories_id'];
						$cs->MoveNext();
					}
					$records['categories'] = implode($this->cat_tree_delimiter,$cats);
				} else {
					$records['categories'] = $cs->fields['categories_id'];
				}
				$records['cat_tree_delimiter'] = $this->cat_tree_delimiter;

				$_lang_data = array();
				// export languages ? ei_language
				if ($this->_recordData['ei_language']==1) {
					foreach ($_language_list as $key => $val) {
						$lang_sql_Product = "SELECT pd.*, su.url_text,su.meta_title,su.meta_keywords,su.meta_description FROM ".TABLE_PRODUCTS_DESCRIPTION." pd, ".TABLE_SEO_URL." su WHERE su.link_id='".$rs->fields['products_id']."' and pd.products_id='".$rs->fields['products_id']."' and su.language_code='".$val['code']."' and pd.language_code='".$val['code']."' and su.link_type='1'";
						$lang_record = $db->Execute($lang_sql_Product);
						if($lang_record->RecordCount() > 0){
							unset($lang_record->fields['products_id']);
							$_lang_data['products_description_'.$val['code']] = _filterText($lang_record->fields['products_description']);
							$_lang_data['products_name_'.$val['code']] = _filterText($lang_record->fields['products_name']);
							$_lang_data['products_short_description_'.$val['code']] = _filterText($lang_record->fields['products_short_description']);
							$_lang_data['url_text_'.$val['code']] = $lang_record->fields['url_text'];
							$_lang_data['meta_title_'.$val['code']] = $lang_record->fields['meta_title'];
							$_lang_data['meta_keywords_'.$val['code']] = $lang_record->fields['meta_keywords'];
							$_lang_data['meta_description_'.$val['code']] = $lang_record->fields['meta_description'];
							$records = array_merge($records,$_lang_data);
						}
					}
				}

				if (!$header_added) {
					$this->_writeHeader($exportedFields,$fp,$this->codecs[$this->type]);
					$header_added = true;
				}

				// Get only values we care of
				$values = array();
				foreach ($exportedFields as $fieldObj) {
					// Not mapped?
					if (($fieldObj->getCsvField() == '') || (substr($fieldObj->getCsvField(), 0, strlen("No selection")) == 'No selection'))
						continue;
					if (!array_key_exists($fieldObj->getStoreField(), $records)) {
						// Constant
						$values[] = $fieldObj->getStoreField();
					} else {
						$values[] = $fieldObj->getValueForExport($records[$fieldObj->getStoreField()], $records);
					}
				}
				if (empty($values)) {
					$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
					die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
				}
				// Write to file
				fputcsv ($fp, $values, $this->delimiter, $this->enclosure);
				$rs->MoveNext();
			}$rs->Close();
			fclose($fp);

		}

		$this->_redirecting();
	}



	/**
	 * write export header to file
	 *
	 * @param fields $records
	 * @param handle $fp
	 * @param string $commandline
	 */
	function _writeHeader($records,&$fp,$commandline) {
		global $language;

		$_language_list = $language->_getLanguageList();
		if ($this->limit_lower==0) {
			$header = array();
			foreach ($records as $fieldObj) {
				if (($fieldObj->getCsvField() == '') || (substr($fieldObj->getCsvField(), 0, strlen("No selection")) == 'No selection'))
					continue;
				$header[]=$fieldObj->getCsvField();
			}
			if (empty($header)) {
				$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
				die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_EXPORT);
			}
			fputcsv ($fp, $header, $this->delimiter, $this->enclosure);
		}
	}

	function _openFile() {

		$file = _SRV_WEBROOT.'export/'.$this->_recordData['ei_filename'];
		if ($this->limit_lower==0 || $this->force_delete) {
			if (file_exists($file)) unlink($file);
		}
		$fp = fopen($file, "a");
		return $fp;
	}

	function _redirecting($additional_params = array()) {
		global $xtLink;

		if ($this->limit_upper<$this->count) {
			// redirect to next step
			global $xtLink;
			$limit_lower =$this->limit_upper;
			$limit_upper =$this->limit_upper+$this->limit;
			$params = 'api=csv_pro_export&id='.$this->ei_id.
				'&limit_lower='.$limit_lower.
				'&limit_upper='.$limit_upper.
				'&timer_start='.$this->timer_start . http_build_query($additional_params);

			if (isset($this->primary)) $params.='&primary='.$this->primary;
			if (isset($this->secondary)) $params.='&secondary='.$this->secondary;
			//$xtLink->_redirect($xtLink->_link(array('default_page'=>'cronjob.php', 'params'=>$params)));
			echo $this->_displayHTML($xtLink->_link(array('default_page'=>'cronjob.php', 'params'=>$params)),$limit_lower,$limit_upper,$this->count);
		} else {

			// insert into log
			$this->_stopExport($this->id);
			echo $this->_htmlHeader();
			echo '- export finished -<br />';
			echo '- exported datasets '.$this->count.'<br />';

			$this->showLog($this->id);
			echo $this->_htmlFooter();
			$this->_clearLog($this->id);
		}
	}
}
?>